from __future__ import division
import time
#import the PCA9685 module.
import osoyoo_PCA9685
import RPi.GPIO as GPIO
#L298N port define
ena = 8
enb = 13
in1 = 9
in2 = 10
in3 = 11
in4 = 12
high_speed=4000
mid_speed=3000
low_speed=2000
# Initialise the PCA9685 using the default address (0x40).
pwm = osoyoo_PCA9685.PCA9685()
# Set frequency to 60hz.
pwm.set_pwm_freq(60)
#Initialise GPIO
GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM)
#set ULTRASONIC SENSOR GPIO Pins
GPIO_TRIGGER1 = 18
GPIO_ECHO1 = 23
GPIO_TRIGGER2 = 24
GPIO_ECHO2 = 25
GPIO_TRIGGER3 = 16
GPIO_ECHO3 = 20
d1,d2,d3 = 0,0,0
  
#set GPIO direction (IN / OUT)
GPIO.setup(GPIO_TRIGGER1, GPIO.OUT)
GPIO.setup(GPIO_ECHO1, GPIO.IN)
GPIO.setup(GPIO_TRIGGER2, GPIO.OUT)
GPIO.setup(GPIO_ECHO2, GPIO.IN)
GPIO.setup(GPIO_TRIGGER3, GPIO.OUT)
GPIO.setup(GPIO_ECHO3, GPIO.IN)
def distance(GPIO_TRIGGER,GPIO_ECHO):
    # set Trigger to HIGH
    GPIO.output(GPIO_TRIGGER, True)
 
    # set Trigger after 0.01ms to LOW
    time.sleep(0.00001)
    GPIO.output(GPIO_TRIGGER, False)
 
    StartTime1 = time.time()
    StopTime1 = time.time()
 
    # save StartTime1
    while GPIO.input(GPIO_ECHO) == 0:
        StartTime = time.time()
 
    # save time of arrival
    while GPIO.input(GPIO_ECHO) == 1:
        StopTime = time.time()
 
    # time difference between start and arrival
    TimeElapsed = StopTime - StartTime
    # multiply with the sonic speed (34300 cm/s)
    # and divide by 2, because there and back
    distance = (TimeElapsed * 34300) / 2
 
    return distance

#Set motor speed
def set_speed(lspeed,rspeed):
    pwm.set_pwm(ena,0,lspeed)
    pwm.set_pwm(enb,0,rspeed)

#Robot car forward
def go_forward():
    pwm.set_pwm(in1,0,4095)   #IN1
    pwm.set_pwm(in2,0,0)      #IN2
    
    pwm.set_pwm(in3,0,4095)   #IN3
    pwm.set_pwm(in4,0,0)      #IN4
#Robot car backwards
def go_back():
    pwm.set_pwm(in1,0,0)      #IN1
    pwm.set_pwm(in2,0,4095)   #IN2
    
    pwm.set_pwm(in3,0,0)      #IN3
    pwm.set_pwm(in4,0,4095)   #IN4

#Robot car turn left
def turn_left():
    pwm.set_pwm(in1,0,4095)   #IN1
    pwm.set_pwm(in2,0,0)      #IN2
    
    pwm.set_pwm(in3,0,0)      #IN3
    pwm.set_pwm(in4,0,4095)   #IN4

#Robot turn right
def turn_right():
    pwm.set_pwm(in1,0,0)      #IN1
    pwm.set_pwm(in2,0,4095)   #IN2
    
    pwm.set_pwm(in3,0,4095)   #IN3
    pwm.set_pwm(in4,0,0)      #IN4

#Robot stop move
def stop():
    set_speed(0,0)

#Reset PCA9685's all channels    
def destroy():
    pwm.set_all_pwm(0,0)

#Robot car moves along the black line
def tracking():
    while True:
        dist1 = distance(GPIO_TRIGGER1,GPIO_ECHO1)
        dist2 = distance(GPIO_TRIGGER2,GPIO_ECHO2)
        dist3 = distance(GPIO_TRIGGER3,GPIO_ECHO3)
        print ("Measured distance1 = %.1f cm " % dist1)
        print ("Measured distance2 = %.1f cm " % dist2)
        print ("Measured distance3 = %.1f cm " % dist3)
        if(dist1<40) :
            d1=1
        else:
            d1=0
        if(dist2<40) :
            d2=1
        else:
            d2=0
        if(dist3<40) :
            d3=1
        else:
            d3=0
 
        ostr=str(d3)+str(d2)+str(d1)
        print (ostr)
        if(ostr=='000'):
            print ("go ahead")
            set_speed(high_speed,high_speed)
            go_forward()
            time.sleep(1)
            stop()
            time.sleep(1)
            continue            
        if(ostr=='100' or ostr=='110'):
            print ("go right")
            set_speed(high_speed,high_speed)
            turn_right()
            time.sleep(1)
            stop()
            time.sleep(1)
            continue
        if(ostr=='001' or ostr=='011' or ostr=='010'):
            print ("go left")
            set_speed(high_speed,high_speed)
            turn_left()
            time.sleep(1)
            stop()
            time.sleep(1)
            continue
        if(ostr=='101' or ostr=='111'):
            print ("go_back")
            set_speed(mid_speed,mid_speed)
            go_back()
            time.sleep(1)
            stop()
            time.sleep(1)
            continue
if __name__ == '__main__':
    try:
	#start to line follow
        tracking()
    except KeyboardInterrupt:
	#robot car stop
        print("Measurement stopped by User")
        destroy()
        GPIO.cleanup()
